<script lang="typescript">
  import Roll from './Roll.svelte'

  import {
    RangeI18nMap,
    SizeI18nMap,
    labeledValues,
  } from '../../module/i18n.js'
  import type { BaseCharacter } from '../../module/model/character.js'
  import type { ModifierDescriptor } from '../../module/model/modifier.js'
  import {
    CoverI18nMap,
    DarknessI18nMap,
    MovementI18nMap,
    SightI18nMap,
    SteepshotI18nMap,
    WindI18nMap,
  } from '../../module/ruleset/rules/enhanced-ranged-combat.js'
  import Checkbox from '../Checkbox.svelte'
  import Select from '../Select.svelte'
  import Slider from '@bulatdashiev/svelte-slider/src/Slider.svelte'
  import { RangeClasses, SizeClasses } from '../../module/model/items.js'
  import { getSettings } from '../../module/utils.js'
  import {
    CoverModifierNames,
    DarknessModifierNames,
    MovementModifierNames,
    SightModifierNames,
    SteepshotModifierNames,
    WindModifierNames,
  } from '../../module/model/rules/enhanced-ranged-combat.js'

  export var localize: (key: string, withPrefix?: boolean) => string
  export var character: BaseCharacter

  const settings = getSettings()

  const useEnhancedCombat = settings.get(
    'dsa-41',
    'enhanced-ranged-combat-rule'
  )

  export var callback: (
    modifiers: Map<string, ModifierDescriptor>,
    options: any
  ) => void

  let modifiers = new Map<string, ModifierDescriptor>()

  let options = {
    sizeClass: 'big',
    rangeClass: 'close',
    darkness: 'daylight',
    sight: 'normal',
    cover: 'none',
    movement: 'slowMovement',
    wind: 'windstill',
    quickshot: false,
    secondAttackInRound: false,
    aimTime: 0,
    isArrowOnBow: false,
    isBowStretched: false,
    usesAxxeleratus: false,
    fray: 0,
    steepshot: 'none',
  }

  const rangeClasses = labeledValues(RangeI18nMap, RangeClasses, localize)
  const sizeClasses = labeledValues(SizeI18nMap, SizeClasses, localize)
  const darknessLevels = labeledValues(
    DarknessI18nMap,
    DarknessModifierNames,
    localize
  )

  const sightLevels = labeledValues(SightI18nMap, SightModifierNames, localize)

  const coverLevels = labeledValues(CoverI18nMap, CoverModifierNames, localize)

  const movementClasses = labeledValues(
    MovementI18nMap,
    MovementModifierNames,
    localize
  )

  const windClasses = labeledValues(WindI18nMap, WindModifierNames, localize)
  const steepshotlasses = labeledValues(
    SteepshotI18nMap,
    SteepshotModifierNames,
    localize
  )

  let aimTime = [options.aimTime]
  $: options.aimTime = aimTime[0]

  let duration = 0
  $: duration = character?.rangedAttackDuration(options) || 0

  $: modifiers = character?.rangedAttackModifiers(options) || new Map()

  let inFray = false
  let adjacentPersons = [2]
  $: options.fray = inFray ? adjacentPersons[0] : 0
</script>

<Roll bind:modifiers {callback} {localize} {options}>
  <div slot="options">
    <div class="container">
      <div>
        {localize('sizeClass')}:
        <Select bind:value={options.sizeClass} items={sizeClasses} />
      </div>

      <div>
        {localize('rangeClass')}:
        <Select bind:value={options.rangeClass} items={rangeClasses} />
      </div>

      {#if useEnhancedCombat}
        <div>
          {localize('darkness')}:
          <Select bind:value={options.darkness} items={darknessLevels} />
        </div>

        <div>
          {localize('sight')}:
          <Select bind:value={options.sight} items={sightLevels} />
        </div>

        <div>
          {localize('cover')}:
          <Select bind:value={options.cover} items={coverLevels} />
        </div>

        <div>
          {localize('movement')}:
          <Select bind:value={options.movement} items={movementClasses} />
        </div>

        <div>
          {localize('wind')}:
          <Select bind:value={options.wind} items={windClasses} />
        </div>

        <div>
          {localize('steepshot')}:
          <Select bind:value={options.steepshot} items={steepshotlasses} />
        </div>
      {/if}
    </div>
    {#if useEnhancedCombat}
      <hr />
      <div class="container">
        <div style="display:flex;">
          <Checkbox bind:checked={options.isArrowOnBow} />
          <div>{localize('arrowOnBow')}</div>
        </div>

        <div style="display:flex;">
          <Checkbox bind:checked={options.isBowStretched} />
          <div>{localize('bowIsStretched')}</div>
        </div>

        <div style="display:flex;">
          <Checkbox bind:checked={options.usesAxxeleratus} />
          <div>{localize('axxeleratus')}</div>
        </div>

        <div style="display:flex;">
          <Checkbox bind:checked={options.quickshot} />
          <div>{localize('quickshot')}</div>
        </div>

        <div style="display:flex;">
          <Checkbox bind:checked={options.secondAttackInRound} />
          <div>{localize('secondAttackInRound')}</div>
        </div>
      </div>
      <hr />
      <div>
        <div style="display:flex;">
          <Checkbox bind:checked={inFray} />
          {localize('personsInFray')}:
          {#if inFray}{adjacentPersons[0]}{/if}
        </div>
        {#if inFray}
          <Slider bind:value={adjacentPersons} min={2} max={12} />
        {/if}
      </div>
      <hr />
      <div>
        {localize('aimTime')}:
        {options.aimTime}
        {localize('actions')}:
        <Slider bind:value={aimTime} min={0} max={8} />
      </div>
    {/if}
    <div>
      {#if useEnhancedCombat}
        <p style=" font-size: x-large;">
          {localize('duration')}:
          {duration}
          {localize('actions')}
        </p>
      {/if}
    </div>
  </div>
</Roll>

<style>
  .container {
    display: grid;
    grid-template-columns: repeat(2, 1fr);
    gap: 10px;
  }

  .container :global(.svelte-select) {
    width: 100%;
  }
</style>
